package org.jeecg.modules.stm.bcs.handle.controller;

import java.util.Arrays;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.bcs.handle.service.IBcsEventStepService;
import org.jeecg.modules.stm.bcs.handle.entity.BcsEventStep;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
 
 
import org.jeecg.common.aspect.annotation.AutoLog;

/**
 * @Description: 步骤方案
 * @Author: jeecg-boot
 * @Date:   2025-09-25
 * @Version: V1.0
 */

@RestController
@RequestMapping("/bcs.handle/bcsEventStep")
@Slf4j
public class BcsEventStepController extends JeecgController<BcsEventStep, IBcsEventStepService> {
	@Autowired
	private IBcsEventStepService bcsEventStepService;
	
	/**
	 * 分页列表查询
	 *
	 * @param bcsEventStep
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "步骤方案-分页列表查询")

	@GetMapping(value = "/list")
	public Result<IPage<BcsEventStep>> queryPageList(BcsEventStep bcsEventStep,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<BcsEventStep> queryWrapper = QueryGenerator.initQueryWrapper(bcsEventStep, req.getParameterMap());
		Page<BcsEventStep> page = new Page<BcsEventStep>(pageNo, pageSize);
		IPage<BcsEventStep> pageList = bcsEventStepService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param bcsEventStep
	 * @return
	 */
	@AutoLog(value = "步骤方案-添加")

	//@RequiresPermissions("bcs.handle:bcs_event_step:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody BcsEventStep bcsEventStep) {
		bcsEventStepService.save(bcsEventStep);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param bcsEventStep
	 * @return
	 */
	@AutoLog(value = "步骤方案-编辑")

	//@RequiresPermissions("bcs.handle:bcs_event_step:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody BcsEventStep bcsEventStep) {
		bcsEventStepService.updateById(bcsEventStep);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "步骤方案-通过id删除")

	//@RequiresPermissions("bcs.handle:bcs_event_step:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		bcsEventStepService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "步骤方案-批量删除")

	//@RequiresPermissions("bcs.handle:bcs_event_step:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.bcsEventStepService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "步骤方案-通过id查询")

	@GetMapping(value = "/queryById")
	public Result<BcsEventStep> queryById(@RequestParam(name="id",required=true) String id) {
		BcsEventStep bcsEventStep = bcsEventStepService.getById(id);
		if(bcsEventStep==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(bcsEventStep);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param bcsEventStep
    */
	//@RequiresPermissions("bcs.handle:bcs_event_step:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, BcsEventStep bcsEventStep) {
        return super.exportXls(request, bcsEventStep, BcsEventStep.class, "步骤方案");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
	//@RequiresPermissions("bcs.handle:bcs_event_step:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, BcsEventStep.class);
    }

}
